uk.ac.starlink.votable

## Class FitsPlusTableBuilder

- java.lang.Object
- - uk.ac.starlink.votable.FitsPlusTableBuilder

- All Implemented Interfaces:
    MultiTableBuilder, TableBuilder

      public class FitsPlusTableBuilder
      extends java.lang.Object
      implements TableBuilder, MultiTableBuilder

  Table builder which can read files in 'fits-plus' format (as written by `FitsPlusTableWriter`). This looks for a primary header in the FITS file which contains the VOTMETA header (in fact it is quite inflexible about what it recognises as this format - see `isMagic(byte[])`) and tries to interpret the data array as a 1-d array of bytes representing the XML of a VOTable document. This VOTable document should have one or more TABLE elements with no DATA content - the table data is got from the extension extension HDUs, one per table, and they must be BINTABLE extensions matching the metadata described by the VOTable.

  The point of all this is so that you can store VOTables in the efficient FITS format (it can be mapped if it's on local disk, which makes table creation practically instantaneous, even for random access) without sacrificing any of the metadata that you want to encode in VOTable format.

  Since:
    27 Aug 2004
  See Also:
    `FitsPlusTableWriter`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FitsPlusTableBuilder()` Default constructor.
    `FitsPlusTableBuilder(WideFits wide)` Constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canImport(java.awt.datatransfer.DataFlavor flavor)` Returns `true` for a flavor with the MIME type "application/fits".
    `java.lang.String` | `getFormatName()` Returns the name of the format which can be read by this handler.
    `static boolean` | `isMagic(byte[] buffer)` Tests whether a given buffer contains bytes which might be the first few bytes of a FitsPlus table.
    `boolean` | `looksLikeFile(java.lang.String location)` Indicates whether the given location string is of a familiar form for this builder.
    `StarTable` | `makeStarTable(DataSource datsrc, boolean wantRandom, StoragePolicy storagePolicy)` Constructs a `StarTable` based on a given `DataSource`.
    `TableSequence` | `makeStarTables(DataSource datsrc, StoragePolicy storagePolicy)` Constructs a sequence of StarTables based on a given DataSource.
    `void` | `streamStarTable(java.io.InputStream in, TableSink sink, java.lang.String pos)` Reads a table from an input stream and writes it a row at a time to a sink.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FitsPlusTableBuilder

          public FitsPlusTableBuilder()

      Default constructor.

    - #### FitsPlusTableBuilder

          public FitsPlusTableBuilder(WideFits wide)

      Constructor.
      Parameters:
        `wide` - convention for representing extended columns; use null to avoid use of extended columns

  - ### Method Detail

    - #### getFormatName

          public java.lang.String getFormatName()

      Description copied from interface: `TableBuilder`
      Returns the name of the format which can be read by this handler. Matching against this string may be used by callers to identify or select this handler from a list.
      Specified by:
        `getFormatName` in interface `TableBuilder`
      Returns:
        one-word description of this handler's format

    - #### looksLikeFile

          public boolean looksLikeFile(java.lang.String location)

      Description copied from interface: `TableBuilder`
      Indicates whether the given location string is of a familiar form for this builder. Implementations should return `true` if there is a good chance that a file with the given `location` can be interpreted by this reader, for instance if it has a suitable file extension.

      This method may be used to guess, on a best-efforts basis, whether this builder is suitable for reading a file from a given location. Attempts may still be made to read inputs for which this method returns false. It is less important for builders that can recognise files by magic number, which is generally preferable to using filenames.

      Specified by:
        `looksLikeFile` in interface `TableBuilder`
      Parameters:
        `location` - the location string, such as a filename or URL (not null)
      Returns:
        true iff there is a good chance that the named input can be interpreted by this reader

    - #### makeStarTable

          public StarTable makeStarTable(DataSource datsrc,
                                         boolean wantRandom,
                                         StoragePolicy storagePolicy)
                                  throws java.io.IOException

      Description copied from interface: `TableBuilder`
      Constructs a `StarTable` based on a given `DataSource`. If the source is not recognised or this builder does not know how to construct a table from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      The `wantRandom` parameter is used to indicate whether, ideally, a random-access table should be returned. There is no requirement for the builder to honour this request, but if it knows how to make both random and non-random tables, it can use this flag to decide which to return.

      Note: the presence of the `wantRandom` parameter is somewhat misleading. TableBuilder implementations usually should, and do, ignore it (it would be removed from the interface if it were not for backward compatibility issues). Regardless of the value of this parameter, implementations should return a random-access table only if it is easy for them to do so; in particular they should not use the supplied `storagePolicy`, or any other resource-expensive measure, to randomise a sequential table just because the `wantRandom` parameter is true.

      Specified by:
        `makeStarTable` in interface `TableBuilder`
      Parameters:
        `datsrc` - the DataSource containing the table resource
        `wantRandom` - whether, preferentially, a random access table should be returned
        `storagePolicy` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        a StarTable made out of `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### makeStarTables

          public TableSequence makeStarTables(DataSource datsrc,
                                              StoragePolicy storagePolicy)
                                       throws java.io.IOException

      Description copied from interface: `MultiTableBuilder`
      Constructs a sequence of StarTables based on a given DataSource. If the source is not recognised or this object does not know how to make tables from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      If the `position` of the data source is not null, then this method should return a sequence containing a single table, the one which would be returned by the `makeStarTable` method with that position.

      Specified by:
        `makeStarTables` in interface `MultiTableBuilder`
      Parameters:
        `datsrc` - the DataSource containing the table resource
        `storagePolicy` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        an array of StarTables read from `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### streamStarTable

          public void streamStarTable(java.io.InputStream in,
                                      TableSink sink,
                                      java.lang.String pos)
                               throws java.io.IOException

      Description copied from interface: `TableBuilder`
      Reads a table from an input stream and writes it a row at a time to a sink. Not all implementations will be able to do this; for instance, extracting the table from the data may be a two-pass process. Implementations which are unable to perform this function should throw a `TableFormatException`.

      The input stream should be prepared for use prior to calling this method, so implementations should not in general attempt to decompress or buffer `istrm`.

      Specified by:
        `streamStarTable` in interface `TableBuilder`
      Parameters:
        `in` - input stream containing table data
        `sink` - destination of the table
        `pos` - position identifier describing the location of the table within the stream; see `DataSource.getPosition()` (may be null)
      Throws:
        `TableFormatException` - if the table can't be streamed or the data is malformed
        `java.io.IOException` - if some other error occurs

    - #### canImport

          public boolean canImport(java.awt.datatransfer.DataFlavor flavor)

      Returns `true` for a flavor with the MIME type "application/fits".
      Specified by:
        `canImport` in interface `TableBuilder`
      Parameters:
        `flavor` - the DataFlavor whose suitability as stream input is to be assessed
      Returns:
        `true` iff this builder reckons it stands a good chance of turning a stream of type `flavor` into a `StarTable`

    - #### isMagic

          public static boolean isMagic(byte[] buffer)

      Tests whether a given buffer contains bytes which might be the first few bytes of a FitsPlus table. The criterion is that it looks like the start of a FITS header, and the first few cards look roughly like this:

               SIMPLE  =              T
               BITPIX  =              8
               NAXIS   =              1
               NAXIS1  =            ???
               VOTMETA =              T

      Parameters:
        `buffer` - byte buffer containing leading few bytes of data
      Returns:
        true if it looks like a FitsPlus file